package de.hdm_stuttgart.mi.sda2.rdbms2ldap.rdbms;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.log4j.Logger;

import de.hdm_stuttgart.mi.sda2.rdbms2ldap.Config;
import de.hdm_stuttgart.mi.sda2.rdbms2ldap.ldap.LdapHandler;

public class RdbmsHandler {

	private static Logger log = Logger
			.getLogger(RdbmsHandler.class);

	static {
		try {
			Class.forName(Config.get("RdbmsHandler.driverClassName"));
		} catch (ClassNotFoundException e) {
			System.err.println("Unable to register JDBC driver '"
					+ Config.get("RdbmsHandler.jdbcUrl") + "'");
			System.exit(1);
		}
	}

	Connection conn = null;

	public void connect() throws SQLException {
		if (null != conn) {
			conn.rollback();
			conn.close();
		}
		conn = DriverManager.getConnection(Config.get("RdbmsHandler.jdbcUrl"),
				Config.get("RdbmsHandler.user"), Config.get("RdbmsHandler.password"));
		conn.setAutoCommit(true);
	}
	
	public void transferGroups(LdapHandler ldapHandler) {
		try {
			Statement stmt = conn.createStatement();
			final ResultSet groups = stmt.executeQuery("SELECT * FROM SysGroup");
			while (groups.next()) {
				ldapHandler.insertGroup(groups.getString("gid"),
						groups.getInt("gidNumber"));
			}
			
		} catch (SQLException e) {
			log.fatal("Unable to insert groups: " + e.getMessage());
		}
	}
	public void transferUsers(LdapHandler ldapHandler) {
		try {
			Statement stmt = conn.createStatement();
			final ResultSet users = stmt.executeQuery("SELECT * FROM SysUser");
			while (users.next()) {
				ldapHandler.insertUser(
						users.getString("uid")
						,users.getInt("uidNumber")
						,users.getInt("primaryGidNumber")
						,users.getString("cname")
						,users.getString("homeDirectory")
						,users.getString("shell")
						);
			}
			
		} catch (SQLException e) {
			log.fatal("Unable to insert userss: " + e.getMessage());
		}
	}
	
}
